import type { ModuleFederationPluginOptions } from '@module-federation/utilities';
import { Compiler } from 'webpack';
export interface FederatedTypesPluginOptions {
    /**
     * Any additional files to be included (besides `ModuleFederationPluginOptions.remotes`) in the emission of Typescript types.
     * I.e. `"files"` in your tsconfig.json.
     * This is useful for global .d.ts files not directly referenced.
     */
    typescriptFilesInclude?: string[];
}
export declare class FederatedTypesPlugin {
    private options;
    private exposedComponents;
    private remoteComponents;
    private distDir;
    private fsCache;
    private typesIndexJsonFilePath;
    private tsCompilerOptions;
    private webpackCompilerOptions;
    private tsDefinitionFilesObj;
    private federatedTypesPluginOptions?;
    private typescriptFolderName;
    private typesIndexJsonFileName;
    constructor(options: ModuleFederationPluginOptions, federatedTypesPluginOptions?: FederatedTypesPluginOptions);
    apply(compiler: Compiler): void;
    private run;
    private importRemoteTypes;
    private extractTypes;
    private getFiles;
    private resolveFilenameWithExtension;
}
